//global variables as a surprise tool that will help us later
::redplayers <- []
::blueplayers <- []
::maxplayers <- MaxClients().tointeger()
::initialized <- false
::roundhasended <- false
::isinfeedbackround <- false
::firstbloodhappened <- false
::roundstarttime <- 0.0
::bluestartingplayers <- 0
::redstartingplayers <- 0
::blueplayersleft <- 0
::redplayersleft <- 0
::gamerules <- Entities.FindByClassname(null,"tf_gamerules")


//convars woooo
Convars.SetValue("mp_disable_respawn_times", 0)
Convars.SetValue("tf_stalematechangeclasstime", casti2f(0x7fa00000))
Convars.SetValue("mp_respawnwavetime", 999999)
Convars.SetValue("mp_disable_respawn_times", 0)


ClearGameEventCallbacks()


function init()
{
  printl("test")
  if(IsInWaitingForPlayers() || isinfeedbackround) return
  
  for(local i = 1; i <= maxplayers; i++)
  {
    local player = PlayerInstanceFromIndex(i)

    if(player == null || !isplayervalid(player)) continue
    
    //put the players in a neat little list
    if(player.GetTeam() == 2)
    {
      redplayers.append(player)
    }
    else
    {
      blueplayers.append(player)
    }
  }
  
  redstartingplayers = redplayers.len()
  bluestartingplayers = blueplayers.len()

  NetProps.SetPropInt(gamerules, "m_iRoundState", 7)
  roundstarttime <- Time()

  initialized = true

  printl("stuff is initialized have a fun day or something")
}

function isplayervalid(player)
{
  return ((player.GetTeam() & 2) && NetProps.GetPropInt(player, "m_lifeState") == 0)
}


function mainthink()
{
  if(!initialized || roundhasended) return -1
  
  blueplayersleft = blueplayers.len()
  redplayersleft = redplayers.len()

  checkteamstatus()

  NetProps.SetPropInt(self,"m_nBlueScore",blueplayersleft)
  NetProps.SetPropInt(self,"m_nRedScore",redplayersleft)

  return -1
}



function OnGameEvent_player_death(params)
{
    if(!initialized) return

    if("userid" in params)
    {
        local ent = null
        while(ent = Entities.FindByClassname(ent,"item_teamflag"))
        {
          ent.Kill()
        }

        local player = GetPlayerFromUserID(params.userid)
        //do we have a first blood?
        if("attacker" in params && !firstbloodhappened)
        {
          local attacker = GetPlayerFromUserID(params.attacker)
          if(attacker.GetClassname() == "player" && attacker != player)
          {
            local timesincestart = Time() - roundstarttime
            //play the correct voicelines
            if(timesincestart < 20.0)
            {
             EntFireByHandle(gamerules, "PlayVOBlue", "Announcer.AM_FirstBloodFast", -1, null, null)
             EntFireByHandle(gamerules, "PlayVORed", "Announcer.AM_FirstBloodFast", -1, null, null)
            }
            else if(timesincestart > 50.0)
            {
             EntFireByHandle(gamerules, "PlayVOBlue", "Announcer.AM_FirstBloodFinally", -1, null, null)
             EntFireByHandle(gamerules, "PlayVORed", "Announcer.AM_FirstBloodFinally", -1, null, null)
            }
            else
            {
             EntFireByHandle(gamerules, "PlayVOBlue", "Announcer.AM_FirstBloodRandom", -1, null, null)
             EntFireByHandle(gamerules, "PlayVORed", "Announcer.AM_FirstBloodRandom", -1, null, null)              
            }
            
            attacker.AddCondEx(37,5.0,attacker)
            firstbloodhappened = true
          }
        }
        
        //did the player actually die or did they use the deadringer?
        if(params.death_flags & 0x20) return

        //if they did remove them from our neat little list
        if(redplayers.find(player) != null)
        {
          redplayers.remove(redplayers.find(player))
        }
        else if(blueplayers.find(player) != null)
        {
          blueplayers.remove(blueplayers.find(player))
        }
    }
}

//function that gets run in the think that can be used to do stuff based on the amount of players left
function checkteamstatus()
{
    if(redplayersleft == 0 && !roundhasended)
    {
     teamwin(3)
     return
    }
    if(blueplayersleft == 0 && !roundhasended)
    {
     teamwin(2)
     return
    }

}

//remove players that disconnected
function OnGameEvent_player_disconnect(params)
{
    local player = GetPlayerFromUserID(params.userid)
    printl(player)
    if(redplayers.find(player) != null)
    {
      printl("red disconnect")
      redplayers.remove(redplayers.find(player))
      return
    }
    if(blueplayers.find(player) != null)
    {
      printl("blue disconnect")
      blueplayers.remove(blueplayers.find(player))
      return
    }
}

//kill players that respawn for some reason
function OnGameEvent_post_inventory_application(params)
{
    if(!initialized) return

    local player = GetPlayerFromUserID(params.userid)

    if(redplayers.find(player) != null || blueplayers.find(player) != null) return

    printl("test")

    player.TakeDamage(450,64,player)
    local ent = null
    while(ent = Entities.FindByClassname(ent,"tf_ammo_pack"))
    {
      if(ent.GetOwner() == player)
      {
        ent.Kill()
        return
      }
    }

}

//winner winner chicken dinner (thanks to LizardOfOz for helping me with some stuff)
function teamwin(winner)
{
    roundhasended = true
    playflawlesslines(winner)
    local roundWin = Entities.FindByClassname(null, "game_round_win");
    if (roundWin == null)
    {
        roundWin = SpawnEntityFromTable("game_round_win",
        {
            win_reason = "2",
            force_map_reset = "1", //not having
            TeamNum = "0",         //these 3 lines
            switch_teams = "0"     //causes the crash when trying to fire game_round_win
        });
    }
    EntFireByHandle(roundWin, "SetTeam", "" + winner, 0, null, null);
    EntFireByHandle(roundWin, "RoundWin", "", 0, null, null);

}


//check if we have a flawless victory
function playflawlesslines(winner)
{
  if(winner == 2 && redplayers.len() == redstartingplayers)
  {
    EntFireByHandle(gamerules, "PlayVOBlue", "Announcer.AM_FlawlessDefeatRandom", -1, null, null)
    EntFireByHandle(gamerules, "PlayVORed", "Announcer.AM_FlawlessVictoryRandom", -1, null, null)
    return
  }
  if(winner == 3 && blueplayers.len() == bluestartingplayers)
  {
    EntFireByHandle(gamerules, "PlayVORed", "Announcer.AM_FlawlessDefeatRandom", -1, null, null)
    EntFireByHandle(gamerules, "PlayVOBlue", "Announcer.AM_FlawlessVictoryRandom", -1, null, null)
  }

}

//function that should be called from a feedbackround relay
function setfeedbackround()
{
  isinfeedbackround = true
}

__CollectGameEventCallbacks(this)